<?php 
  // This PHP program generates encrypted/hashed passwords from a 
  // database table.
  // Must run in this form in a "black" window (a console window)
  // Expects  the unencrypted passwords in a database table called "pwd".
  // The SQL database is accessed via ODBC./
  // The program updates a column with a MD5-hashed value that can be used 
  // as an encrypted password.
  //
  // Structure of input/output table  pwd:
  //   id integer
  //   pw1 varchar   (= unencrypted password)
  //   pw2 varchar   (= encrypted/hashed password (MD5))
  //
  // SQL script for the creation of this table:
  //   create table pwd(id integer, pw1 varchar(50),pw2 varchar(50));
  //
  // Execute:
  //    php -f php_md5_db.php
  //
  // Copyright Dr. E.Huckert 11-2010
  
  // --------------------------------------------------
  // Returns a random value
  function makeRandom()
  {
    $salt = "";
    for ($i=0; $i <= 32; $i++) 
    {
      $d = rand(1,30) % 2;
      $salt .= $d ? chr(rand(65,90)) : chr(rand(48,57));
    }
    return $salt;
  }    

  // ---------------------------------------------------
  // Returns a  MD5 Hash
  function makeHash($inp)
  {
    $line = trim($line);
    $hashed = md5($inp);
    return $hashed;
  }
  //
  // ---------------------------------------------------
  // The main() routine starts here
  //
  // Open an ODBC connection
  $odbcDsn  = "SQLITE";   // ODBC data service name
  $userName = "";         // user name for database
  $userPwd  = "";         // password for database
  $conn = odbc_connect($odbcDsn, $userName, $userPwd);
  if ($conn == 0)
  {
    print "Database ERROR!!!\n";
    exit(1);
  }
  odbc_autocommit($conn, 1);
  //
  // select all  unencrypted passwords  from the database table pwd
  $sql = "select id,pw1 from pwd";
  print "select sql=".$sql."\n";
  $resultId = odbc_exec($conn, $sql);
  //
  while (true)
  {
    // fetch the next row from the select result
    $rowResult = odbc_fetch_row($resultId);
    if ($rowResult == 0)
      break;
    $id  = odbc_result($resultId, 1);
    $pw1 = odbc_result($resultId, 2);
    print "id=".$id." pwd=".$pw1."\n";
    // generate a randomw value
    $zufall = makeRandom();
    // generate a MD5 hash value from the unencrypted password and the random value
    $newPassword = makeHash($pw1.$zufall);
    //print "MD5 hashed: ".$newPassword."\n";
    print $newPassword."\n";
    // update the database table pwd : add the encrypted password
    $sql = "update pwd set pw2='$newPassword' where id=$id";
    print "update sql=".$sql."\n";
    $updateResult = odbc_exec($conn, $sql);
    if ($updateResult == 0)
    {
      print "ERROR DB update\n";
      break;
    }
  }   // end while(true)
  //
  odbc_close($conn);
?>
